﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using PRIORLib;
using ATMCD32CS;
//Line Scan


namespace Raman
{





    public partial class Form1 : Form
    {

        AndorSDK AndorObj = new AndorSDK();
        internal ScanClass scan;
        internal StageClass xyStage;



        // Define the drawing area
        private Rectangle PlotArea;

        //Unit defined in world coordinate system:
        private float xMin = 0f;
        private float xMax = 1024f;
        private float yMin = 000f;
        private float yMax = 1000f;
        private int nPoints = 1024;

        // Define the ofset in pixel:
        private int offset = 10;

        private PointF Point2D(PointF ptf)
        {
            PointF aPoint = new PointF();
            if (ptf.X < xMin || ptf.X > xMax || ptf.Y < yMin || ptf.Y > yMax)
            {
                ptf.X = Single.NaN;
                ptf.Y = Single.NaN;
            }
            aPoint.X = PlotArea.X + (ptf.X - xMin) * PlotArea.Width / (xMax - xMin);
            aPoint.Y = PlotArea.Bottom - (ptf.Y - yMin) * PlotArea.Height / (yMax - yMin);
            return aPoint;
        }


        public Form1()
        {
            InitializeComponent();
            this.SetStyle(ControlStyles.ResizeRedraw, true);


        }

        protected override void OnPaint(PaintEventArgs e)
        {



            Graphics g = e.Graphics;
            g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighSpeed;

            //Calculate the location and size of the drawing area
            //within which we want to draw the graphics:
            Rectangle ChartArea = ClientRectangle;


            ChartArea.Height = Convert.ToInt16(ChartArea.Height * 0.75);
            ChartArea.Width = Convert.ToInt16(ChartArea.Width * 0.8);

            PlotArea = new Rectangle(ChartArea.Location, ChartArea.Size);
            PlotArea.Inflate(-offset, -offset);

            Brush b = new SolidBrush(Color.White);
            g.FillRectangle(b, PlotArea);
            b.Dispose();


            //Draw PlotArea black rectangle
            g.DrawRectangle(Pens.Black, PlotArea);



            if (this.chkSpc1.Checked == true)
            {
                PointF[] pt1 = new PointF[1024];
                for (int i = 0; i < nPoints; i++)
                {
                    pt1[i] = new PointF(i / 1.0f, (float)Global.Spectrum1[i]);
                }
                for (int i = 1; i < nPoints; i++)
                {
                    g.DrawLine(Pens.Red, Point2D(pt1[i - 1]), Point2D(pt1[i]));
                }
            }


            if (this.chkSpc2.Checked == true)
            {
                PointF[] pt2 = new PointF[1024];
                for (int i = 0; i < nPoints; i++)
                {
                    pt2[i] = new PointF(i / 1.0f, (float)Global.Spectrum2[i]);
                }
                for (int i = 1; i < nPoints; i++)
                {
                    g.DrawLine(Pens.Green, Point2D(pt2[i - 1]), Point2D(pt2[i]));
                }
            }



            if (this.chkSpc3.Checked == true)
            {
                PointF[] pt3 = new PointF[1024];
                for (int i = 0; i < nPoints; i++)
                {
                    pt3[i] = new PointF(i / 1.0f, (float)Global.Spectrum3[i]);
                }
                for (int i = 1; i < nPoints; i++)
                {
                    g.DrawLine(Pens.Blue, Point2D(pt3[i - 1]), Point2D(pt3[i]));
                }
            }



            if (this.chkSpc4.Checked == true)
            {
                PointF[] pt4 = new PointF[1024];
                for (int i = 0; i < nPoints; i++)
                {
                    pt4[i] = new PointF(i / 1.0f, (float)Global.Spectrum4[i]);
                }
                for (int i = 1; i < nPoints; i++)
                {
                    g.DrawLine(Pens.Magenta, Point2D(pt4[i - 1]), Point2D(pt4[i]));
                }
            }


            if (Global.DataReady == 1)
            {

                if (this.chkAutoscale.Checked == true) //fa autoscale
                {
                    
                }
                
                
                PointF[] ptTmp = new PointF[1024];
                for (int i = 0; i < nPoints; i++)
                {
                    ptTmp[i] = new PointF(i / 1.0f, (float)Global.tmpSpectrum[i]);
                }
                for (int i = 1; i < nPoints; i++)
                {
                    g.DrawLine(Pens.Blue, Point2D(ptTmp[i - 1]), Point2D(ptTmp[i]));
                }
            }


            g.Dispose();



        }

        





        




        private void Spectrum1_Click(object sender, EventArgs e)
        {

            // Create an OpenFileDialog object.
            OpenFileDialog openFile1 = new OpenFileDialog();

            // Initialize the OpenFileDialog to look for dat files.
            openFile1.Filter = "Raw|*.dat";
            

            // Check if the user selected a file from the OpenFileDialog.
            if (openFile1.ShowDialog() == System.Windows.Forms.DialogResult.OK) // if yes the path is contained in the openFile1.FileName variable
            {
                //create a file handle with properties
                FileStream fstr = new FileStream(openFile1.FileName, FileMode.Open, FileAccess.Read);

                string[] tmpString = openFile1.FileName.Split('\\');//imparte pathul in bucati
                this.Spectrum1.Text = tmpString[tmpString.Length - 1];// seteaza textul pe buton egal cu ultima bucata, adica numele fisierului

                //create a binary reader to extract the data from the file, sizeof is used to increase the pointer, in multiple of 4 for int32
                using (BinaryReader BinReadTemp = new BinaryReader(fstr))
                {
                    int pos = 0; //position pointer for the reading process
                    int length = (Int32)BinReadTemp.BaseStream.Length; //length of the file
                   
                    while (pos < length)
                    {
                        Global.Spectrum1[pos / sizeof(Int32)] = BinReadTemp.ReadInt32();
                        pos += sizeof(Int32);
                    }
                }

               // close the file
                fstr.Close();

                              
                this.chkSpc1.Enabled = true;
                this.chkSpc1.Checked = true;
                this.Invalidate();
            }



        }
        private void Spectrum2_Click(object sender, EventArgs e)
        {

            // Create an OpenFileDialog object.
            OpenFileDialog openFile1 = new OpenFileDialog();

            // Initialize the OpenFileDialog to look for dat files.
            openFile1.Filter = "Raw|*.dat";

            // Check if the user selected a file from the OpenFileDialog.
            if (openFile1.ShowDialog() == System.Windows.Forms.DialogResult.OK) // if yes the path is contained in the openFile1.FileName variable
            {
                //create a file handle with properties
                FileStream fstr = new FileStream(openFile1.FileName, FileMode.Open, FileAccess.Read);

                string[] tmpString = openFile1.FileName.Split('\\');//imparte pathul in bucati
                this.Spectrum2.Text = tmpString[tmpString.Length - 1];// seteaza textul pe buton egal cu ultima bucata, adica numele fisierului

                //create a binary reader to extract the data from the file, sizeof is used to increase the pointer, in multiple of 4 for int32
                using (BinaryReader BinReadTemp = new BinaryReader(fstr))
                {
                    int pos = 0; //position pointer for the reading process
                    int length = (Int32)BinReadTemp.BaseStream.Length; //length of the file
                    while (pos < length)
                    {
                        Global.Spectrum2[pos / sizeof(Int32)] = BinReadTemp.ReadInt32();
                        pos += sizeof(Int32);
                    }
                }

                // close the file
                fstr.Close();
                this.chkSpc2.Enabled = true;
                this.chkSpc2.Checked = true;
                this.Invalidate();
            }



        }
        private void Spectrum3_Click(object sender, EventArgs e)
        {
            // Create an OpenFileDialog object.
            OpenFileDialog openFile1 = new OpenFileDialog();

            // Initialize the OpenFileDialog to look for dat files.
            openFile1.Filter = "Raw|*.dat";

            // Check if the user selected a file from the OpenFileDialog.
            if (openFile1.ShowDialog() == System.Windows.Forms.DialogResult.OK) // if yes the path is contained in the openFile1.FileName variable
            {
                //create a file handle with properties
                FileStream fstr = new FileStream(openFile1.FileName, FileMode.Open, FileAccess.Read);
                string[] tmpString = openFile1.FileName.Split('\\');//imparte pathul in bucati
                this.Spectrum3.Text = tmpString[tmpString.Length - 1];// seteaza textul pe buton egal cu ultima bucata, adica numele fisierului
                //create a binary reader to extract the data from the file, sizeof is used to increase the pointer, in multiple of 4 for int32
                using (BinaryReader BinReadTemp = new BinaryReader(fstr))
                {
                    int pos = 0; //position pointer for the reading process
                    int length = (Int32)BinReadTemp.BaseStream.Length; //length of the file
                    while (pos < length)
                    {
                        Global.Spectrum3[pos / sizeof(Int32)] = BinReadTemp.ReadInt32();
                        pos += sizeof(Int32);
                    }
                }
                // close the file
                fstr.Close();
                this.chkSpc3.Enabled = true;
                this.chkSpc3.Checked = true;
                this.Invalidate();
            }

        }
        private void Spectrum4_Click(object sender, EventArgs e)
        {
            // Create an OpenFileDialog object.
            OpenFileDialog openFile1 = new OpenFileDialog();

            // Initialize the OpenFileDialog to look for dat files.
            openFile1.Filter = "Raw|*.dat";

            // Check if the user selected a file from the OpenFileDialog.
            if (openFile1.ShowDialog() == System.Windows.Forms.DialogResult.OK) // if yes the path is contained in the openFile1.FileName variable
            {
                //create a file handle with properties
                FileStream fstr = new FileStream(openFile1.FileName, FileMode.Open, FileAccess.Read);
                string[] tmpString = openFile1.FileName.Split('\\');//imparte pathul in bucati
                this.Spectrum4.Text = tmpString[tmpString.Length - 1];// seteaza textul pe buton egal cu ultima bucata, adica numele fisierului
                //create a binary reader to extract the data from the file, sizeof is used to increase the pointer, in multiple of 4 for int32
                using (BinaryReader BinReadTemp = new BinaryReader(fstr))
                {
                    int pos = 0; //position pointer for the reading process
                    int length = (Int32)BinReadTemp.BaseStream.Length; //length of the file
                    while (pos < length)
                    {
                        Global.Spectrum4[pos / sizeof(Int32)] = BinReadTemp.ReadInt32();
                        pos += sizeof(Int32);
                    }
                }
                // close the file
                fstr.Close();
                this.chkSpc4.Enabled = true;
                this.chkSpc4.Checked = true;
                this.Invalidate();
            }
        }


        private void Form1_Load(object sender, EventArgs e)
        {
            uint a = AndorObj.Initialize("dummy");//initializeaza softul andor

            a = AndorObj.SetCoolerMode(1);
            a = AndorObj.SetTemperature(-80); //
            a = AndorObj.CoolerON();//
            a = AndorObj.SetAcquisitionMode(1);// 1-singlescan
            int first = new int();//trebe sa returneze valoarea 50
            int gap = new int();
            a = AndorObj.SetReadMode(0);
            //a = AndorObj.SetReadMode(1); // 0-FVB;1-multitrack
            //a = AndorObj.SetMultiTrack(1, 46, 8, ref first, ref gap);//trackul intre 50 si 90
            
            


            scan = new ScanClass(); //creaza clasa scan pt setarea stagiului
            xyStage = new StageClass(); //creaza clasa xyStage pt manevrarea stagiului
            int pci_port = 4; //srial port com1
            scan.Connect(ref pci_port);//initializarea stagiului
            //scan.RestoreDefaults();// cind stagiul o ia razna activeaza instructiunea asta
            double encX; double encY; xyStage.GetPosition(out encX, out encY);// citeste pozitia pe X si pe Y a stagiului 
            this.xPoz.Text = Convert.ToString(encX); this.yPoz.Text = Convert.ToString(encY);//initializeaza afisarea pt X si Y la pornirea programumlui
            xyStage.XHostDirection = -1;
            xyStage.YHostDirection = -1;
            xyStage.MaxAcceleration = 1000;
            xyStage.MaxSpeed = 100;

        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            scan.DisConnect();
        }


        private void xyUpdate()
        {

            double encX; double encY; xyStage.GetPosition(out encX, out encY);// citeste pozitia pe X si pe Y a stagiului 
            this.xPoz.Text = Convert.ToString(encX); this.yPoz.Text = Convert.ToString(encY);//initializeaza afisarea pt X si Y la pornirea programumlui
            this.xPoz.Refresh(); this.yPoz.Refresh();
        }

        private void tmTimer_Tick(object sender, EventArgs e)
        {
            xyUpdate();
            float T=new float();
            uint a = AndorObj.GetTemperatureF(ref T);
            this.lblTemp.Text = Convert.ToString(T);
        }

        private void absMove_Click(object sender, EventArgs e)
        {
            xyStage.MoveToAbsolute(Convert.ToDouble(this.xPoz.Text), Convert.ToDouble(this.yPoz.Text));
            int moving = 1;
            do //verifica daca stagiul este in miscare inainte de a merge mai departe
            {
                scan.IsMoving(out moving);
                Application.DoEvents();

            } while (moving != 0);
            xyUpdate();
        }

        private void zeroPoz_Click(object sender, EventArgs e)
        {
            //xyStage.SetPosition(0, 0);
            xyUpdate();
        }

        private void rlTime_CheckedChanged(object sender, EventArgs e)
        {
            if (rlTime.Checked == true)
            {
                tmTimer.Enabled = true;
            }
            else
            {
                tmTimer.Enabled = false;
            }

        }

        private void Start_Click(object sender, EventArgs e)
        {

            double ofsetX; double ofsetY; xyStage.GetPosition(out ofsetX, out ofsetY);
            uint a = AndorObj.SetExposureTime(float.Parse(this.IntTime.Text)); //steaza integration time
            
            
            
            this.rlTime.Checked = false;


            double ticks = System.Environment.TickCount;



            for (int i = 1; i <= Convert.ToDouble(this.Ysteps.Text); i++)
            {


                for (int j = 1; j <= Convert.ToDouble(this.Xsteps.Text); j++)
                {
                    



                    xyStage.MoveToAbsolute(ofsetX, ofsetY + Convert.ToDouble(this.StepSize.Text) * (j - 1));
                    int movingX = 1;
                    do //verifica daca stagiul este in miscare inainte de a merge mai departe
                    {
                        scan.IsMoving(out movingX);
                        Application.DoEvents();

                    } while (movingX != 0);
                    xyUpdate();




                    string FilePath = "C:\\Titi\\Stem cells\\1\\cell" + j + "_" + i + ".dat";
                     //string FilePath = "C:\\Adrian\\1\\cell" + j + "_" + i + ".dat";
                    
                    //Data acquisition//
                    Global.DataReady = 0;

                    a = AndorObj.StartAcquisition();
                    int S = new int();
                    do
                    {
                        AndorObj.GetStatus(ref S);
                        Application.DoEvents();

                    } while (S == 20072);

                    a = AndorObj.GetAcquiredData(Global.tmpSpectrum, 1024);
                    Global.DataReady = 1;
                    DisplayUpdate();
                    a = AndorObj.SaveAsRaw(FilePath, 2);//save data
                    //Data acquisition//
                    

                }

                //xyStage.MoveToAbsolute(ofsetX, ofsetY + Convert.ToDouble(this.StepSize.Text) * j);
                //int movingY = 1;
                //do //verifica daca stagiul este in miscare inainte de a merge mai departe
                //{
                   // scan.IsMoving(out movingY);
                   // Application.DoEvents();


               // } while (movingY != 0);

                


               // xyUpdate();


            }

            xyStage.MoveToAbsolute(ofsetX , ofsetY );


           
            this.lblMeasurement.Text=Convert.ToString(System.Environment.TickCount - ticks);


        }



         private void Abort_Click(object sender, EventArgs e)
        {

            
            
        }




        private void MultiFiles_Click(object sender, EventArgs e)
        {// it needs Graph form to operate

            OpenFileDialog openFile1 = new OpenFileDialog();// Create an OpenFileDialog object.
            openFile1.Filter = "Raw|*.dat";// Filter to show only Andors *.dat files.
            openFile1.Multiselect = true; //allows the selection of multiple files

            if (openFile1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            { //Check if the user selected a file 

                foreach (string item in openFile1.FileNames)
                {//openFile1.FileName struct containes the files selected 

                    Graph myForm = new Graph(); //crate a new Graph form for each spectrum to be displayed
                    FileStream fstr = new FileStream(item, FileMode.Open, FileAccess.Read);// open a file handlle
                    myForm.Text = item; //print the file path in the form top bar

                    using (BinaryReader BinReadTemp = new BinaryReader(fstr))
                    {//use a binary reader with a step of Int32 to read the data 

                        int pos = 0; //position pointer for the reading process

                        while (pos < (Int32)BinReadTemp.BaseStream.Length)
                        {
                            myForm.tmpdata[pos / sizeof(Int32)] = BinReadTemp.ReadInt32();// each new form has a public tmpdata variable to store its spectrum
                            pos += sizeof(Int32);
                        }
                    }

                    fstr.Close();//clean up, realease the file handlle
                    myForm.Show();// show the new form
                    myForm.Invalidate(); //force the form to be redrawn

                }
            }
        }

        private void chkSpc1_CheckedChanged(object sender, EventArgs e){ this.Invalidate(); }
        private void chkSpc2_CheckedChanged(object sender, EventArgs e){this.Invalidate();}
        private void chkSpc3_CheckedChanged(object sender, EventArgs e){ this.Invalidate(); }
        private void chkSpc4_CheckedChanged(object sender, EventArgs e){this.Invalidate();}
        private void min_ValueChanged(object sender, EventArgs e) { yMin = (float)this.min.Value; this.min.Refresh(); }
        private void max_ValueChanged(object sender, EventArgs e) { yMax = (float)this.max.Value; this.min.Refresh(); }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            //AndorObj.CoolerOFF();
            //int detTemperature = 0;
            //do
            //{

              //  AndorObj.GetTemperature(ref detTemperature);

            //} while (detTemperature < -50);


            AndorObj.ShutDown();
        }

       

        private void chkAutoscale_CheckedChanged(object sender, EventArgs e)
        {

            if (this.chkAutoscale.Checked == false)
            {
                this.min.ReadOnly = false;
                this.max.ReadOnly = false;
                

            }
            else
            {
                this.min.ReadOnly = true;
                this.max.ReadOnly = true;

            }

            DisplayUpdate();
            

        }


        private void DisplayUpdate()
        {
            

            if (this.chkAutoscale.Checked == true)
            {
                this.min.Value = Convert.ToDecimal(Global.MinData(Global.tmpSpectrum));
                this.max.Value = Convert.ToDecimal(Global.MaxData(Global.tmpSpectrum));

            }

            this.Invalidate();


        }


    }

}



