﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Raman
{
    public partial class Graph : Form
    {

        public Int32[] tmpdata = new Int32[1024]; //variable to hold the spectrum on particular form
        


        // Define the drawing area
        private Rectangle PlotArea;

        //Unit defined in world coordinate system:
        private float xMin = 0f;
        private float xMax = 1024f;
        private float yMin = 000f;
        private float yMax = 1000f;
        private int nPoints = 1024;

        // Define the ofset in pixel:
        private int offset = 10;

        private PointF Point2D(PointF ptf)
        {
            PointF aPoint = new PointF();
            if (ptf.X < xMin || ptf.X > xMax || ptf.Y < yMin || ptf.Y > yMax)
            {
                ptf.X = Single.NaN;
                ptf.Y = Single.NaN;
            }
            aPoint.X = PlotArea.X + (ptf.X - xMin) * PlotArea.Width / (xMax - xMin);
            aPoint.Y = PlotArea.Bottom - (ptf.Y - yMin) * PlotArea.Height / (yMax - yMin);
            return aPoint;
        }


        public Graph()
        {
            InitializeComponent();
            this.SetStyle(ControlStyles.ResizeRedraw, true);
        }




        protected override void OnPaint(PaintEventArgs e)
        {

            Int32 Max = tmpdata[0];
            foreach (Int32 element in tmpdata)
            {
                Max = System.Math.Max(Max, element);
            }
            yMax = (float)Max;

            Int32 Min = tmpdata[0];
            foreach (Int32 element in tmpdata)
            {
                Min = System.Math.Min(Min, element);
            }
            yMin = (float)Min;





            Graphics g = e.Graphics;
            g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighSpeed;
            Rectangle ChartArea = ClientRectangle;
            PlotArea = new Rectangle(ChartArea.Location, ChartArea.Size);
            PlotArea.Inflate(-offset, -offset);
            Brush b = new SolidBrush(Color.White);
            g.FillRectangle(b, PlotArea);
            b.Dispose();
            g.DrawRectangle(Pens.Black, PlotArea);

            PointF[] pt1 = new PointF[1024];
            for (int i = 0; i < nPoints; i++)
            {
                pt1[i] = new PointF(i / 1.0f, (float)tmpdata[i]);
            }
            for (int i = 1; i < nPoints; i++)
            {
                g.DrawLine(Pens.Red, Point2D(pt1[i - 1]), Point2D(pt1[i]));
            }

            

            g.Dispose();



        }

    }
}
